Index: sandbox/expresso-solr/expressoMail1_2/inc/class.imap_functions.inc.php
===================================================================
--- sandbox/expresso-solr/expressoMail1_2/inc/class.imap_functions.inc.php	(revision 7552)
+++ sandbox/expresso-solr/expressoMail1_2/inc/class.imap_functions.inc.php	(revision 8056)
@@ -4005,4 +4005,5 @@
 		$return = array();
 		$folders = $this->get_folders_list();
+		$useSolr = false;		
 
 		$j = 0;
@@ -4200,7 +4201,11 @@
 
 	function search_msg( $params = false )
-	{
-	
+	{	
 		include '../prototype/api/controller.php';
+		include 'solrclient/library/Solarium/Autoloader.php';
+		Solarium_Autoloader::register();
+
+		$useSolr = false;
+
 		if(strpos($params['condition'],"#")===false)
 		{ //local messages
@@ -4212,185 +4217,472 @@
 		}
 		
-		$params['page'] = $params['page'] * 1;
-
-	    if( is_array($search) )
-	    {
-			$search = array_unique($search); // Remove duplicated folders
-			$search_criteria = '';
-			$search_result_number = $_SESSION['phpgw_info']['user']['preferences']['expressoMail']['search_result_number'];
-			foreach($search as $tmp)
-			{
-				$tmp1 = explode("##",$tmp);
-				$sum = 0;
-				$name_box = $tmp1[0];
-				unset($filter);
-				foreach($tmp1 as $index => $criteria)
+		if(isset($_SESSION['phpgw_info']['expresso']['expressoMail']['expressoMail_enable_solr']) && $_SESSION['phpgw_info']['expresso']['expressoMail']['expressoMail_enable_solr'] === 'true')
+		{
+			$useSolr = true;
+		}
+		$count = 0;
+		
+		if($useSolr == true)
+		{
+			$params['page'] = $params['page'] * 1;
+
+			if( is_array($search) )
+	   		{
+				$search = array_unique($search); // Remove duplicated folders
+				$search_criteria = '';
+				$search_result_number = $_SESSION['phpgw_info']['user']['preferences']['expressoMail']['search_result_number'];
+				
+				$solrConfig = array(
+						'adapteroptions' => array(
+						'host' => '127.0.0.1',
+					        'port' => 8983,
+		        			'path' => '/solr/',
+						)
+					);
+				// create a client instance
+				$solariumClient = new Solarium_Client($solrConfig);
+				$solrQuery = $solariumClient->createSelect();
+				$usernameAux = $this->username;
+				$solrSearchString = "";
+
+				foreach($search as $tmp)
 				{
-					if ($index != 0 && strlen($criteria) != 0)
+					$tmp1 = explode("##",$tmp);
+					$sum = 0;
+					$name_box = $tmp1[0];
+					$filter = "";
+					$solrSearchString = "(";
+					
+					foreach($tmp1 as $index => $criteria)
 					{
-						$filter_array = explode("<=>",html_entity_decode(rawurldecode($criteria)));
-						$filter .= " ".$filter_array[0];
-						if (strlen($filter_array[1]) != 0)
+						if ($index != 0 && strlen($criteria) != 0)
 						{
-							if ( trim($filter_array[0]) != 'BEFORE' &&
-								 trim($filter_array[0]) != 'SINCE' &&
-								 trim($filter_array[0]) != 'ON')
+							$filter_array = explode("<=>",html_entity_decode(rawurldecode($criteria)));
+							//$filter .= " ".$filter_array[0];
+							if (strlen($filter_array[1]) != 0)
 							{
-							    $filter .= '"'.$filter_array[1].'"';
-							}else if(trim($filter_array[0]) == 'BEFORE' ){
-                                                            $filter .= '"'.$this->make_search_date($filter_array[1],true).'"';
-							}else{
-                                                            $filter .= '"'.$this->make_search_date($filter_array[1]).'"';
-                                                        }
+								
+								$filter_array[1] = mb_convert_encoding($filter_array[1], 'UTF-8',mb_detect_encoding($filter_array[1].'x', 'UTF-8, ISO-8859-1'));
+
+								if ( strlen(trim($solrSearchString)) > 1 )
+								{
+									$solrSearchString .= " OR ";
+								}
+								
+								
+								if ( trim($filter_array[0]) == 'SUBJECT' )
+								{
+									$solrSearchString .= "subject:\"".trim($filter_array[1])."\"";
+								}
+								else if ( trim($filter_array[0]) == 'FROM' )
+								{
+									$solrSearchString .= "from:\"".trim($filter_array[1])."\"";
+								}
+								else if ( trim($filter_array[0]) == 'TO' )
+								{
+									$solrSearchString .= "to:\"".trim($filter_array[1])."\"";
+								}
+								else if ( trim($filter_array[0]) == 'BODY' )
+								{
+									$solrSearchString .= "content:\"".trim($filter_array[1])."\"";
+								}
+								else if ( trim($filter_array[0]) == 'CC' )
+								{
+									$solrSearchString .= "copyto:\"".trim($filter_array[1])."\"";
+								}
+							}
 						}
 					}
+
+					$solrSearchString .= ")";
+
+					$name_box = mb_convert_encoding(utf8_decode($name_box), "UTF7-IMAP", "ISO-8859-1");
+					if(count(explode("/", $name_box)) > 1 )
+					{
+						$arrayAux = explode("/", $name_box);
+						$iArrayAux = count(explode("/", $name_box));
+						
+						$name_box = $arrayAux[$iArrayAux-1];
+					}
+
+
+					$solrQuery->setQuery("$solrSearchString AND user:$usernameAux AND folder:$name_box" );
+					$solrQuery->setFields(array('id', 'msg_no'));
+					$solrQuery->addSort("sent_date", "desc");
+					// override the default row limit of 10 by setting rows to 50
+					$solrQuery->setRows(50);
+					// this executes the query and returns the result
+					$resultset = $solariumClient->select($solrQuery);
+				
+					$count += count($resultset); 
+
+					//$filter = $this->remove_accents($filter);
+
+					//Este bloco tem a finalidade de transformar o login (quando numerico) das pastas compartilhadas em common name
+					/*if ($_SESSION['phpgw_info']['user']['preferences']['expressoMail']['uid2cn'] && substr($name_box,0,4) == 'user')
+					{
+						$folder_name = explode($this->imap_delimiter,$name_box);
+						$this->ldap = new ldap_functions();
+						
+						if ($cn = $this->ldap->uid2cn($folder_name[1]))
+						{
+							$folder_name[1] = $cn;
+						}
+						$folder_name = implode($this->imap_delimiter,$folder_name);
+					}
+					else
+					{
+						$folder_name = mb_convert_encoding(utf8_decode($name_box), "UTF7-IMAP", "ISO-8859-1" );
+					}
+				
+					//print_r($filter);
+					//print("<br/>");
+				
+				        $this->open_mbox($name_box);
+
+					if (preg_match("/^.?\bALL\b/", $filter))
+					{ 
+						// Quick Search, note: this ALL isn't the same ALL from imap_search
+						$all_criterias = array ("TO","SUBJECT","FROM","CC");
+						
+						foreach($all_criterias as $criteria_fixed)
+						{
+							$_filter = $criteria_fixed . substr($filter,4);
+						
+							$search_criteria = imap_search($this->mbox, $_filter, SE_UID);
+						
+							if(is_array($search_criteria))
+							{
+								foreach($search_criteria as $new_search)
+								{
+									$elem = $this->get_info_head_msg($new_search);
+									$elem['udate']       = gmdate('d/m/Y', $elem['udate'] + $this->functions->CalculateDateOffset()); 
+									$elem['boxname'] = mb_convert_encoding( $name_box, "ISO-8859-1", "UTF7-IMAP" );
+									$elem['uid'] = $new_search;
+        	                                                        // compare dates in ordering /
+									$elem['udatecomp'] = substr ($elem['udate'], -4) ."-". substr ($elem['udate'], 3, 2) ."-". substr ($elem['udate'], 0, 2);
+									$retorno[] = $elem; 
+								}
+							}
+						}
+					}*/
+					//else
+					//{
+					$imap = $this->open_mbox( $name_box );
+					foreach ($resultset as $document)
+					{	
+						$v = $document['msg_no'];
+					
+						$new_search = imap_headerinfo ( $imap,  imap_msgno($imap, $v) );
+						if ($new_search->message_id != $document['id'])
+						{
+							continue;
+						}
+
+						//$search_criteria = imap_search($this->mbox, $filter, SE_UID);
+						
+						/*if($_SESSION['phpgw_info']['user']['preferences']['expressoMail']['use_important_flag'])
+						{
+							if((!strpos($filter,"FLAGGED") === false) || (!strpos($filter,"UNFLAGGED") === false))
+							{
+								$num_msgs = imap_num_msg($this->mbox);
+								$flagged_msgs = array();
+								for ($i=$num_msgs; $i>0; $i--)
+								{
+									$iuid = @imap_uid($this->mbox,$i);
+									$header = $this->get_header($iuid);
+									if(trim($header->Flagged))
+									{
+										$flagged_msgs[$i] = $iuid;
+									}
+								}
+								
+								if((count($flagged_msgs) >0) && (strpos($filter,"UNFLAGGED") === false))
+								{
+									$arry_diff = is_array($search_criteria) ? array_diff($flagged_msgs,$search_criteria):$flagged_msgs;
+									foreach($arry_diff as $msg)
+									{
+										$search_criteria[] = $msg;
+									}
+								}
+								else if((count($flagged_msgs) >0) && (is_array($search_criteria)) && (!strpos($filter,"UNFLAGGED") === false))
+								{
+									$search_criteria = array_diff($search_criteria,$flagged_msgs);
+								}
+							}
+						}*/
+
+						//if( is_array( $search_criteria) )
+						//{
+						//	foreach($search_criteria as $new_search)
+						//	{
+								
+
+								$elem = $this->get_info_head_msg( $new_search );
+
+								$elem['udate']       = gmdate('d/m/Y', $elem['msg_number']->udate + $this->functions->CalculateDateOffset());
+								$elem['boxname'] = mb_convert_encoding( $name_box, "ISO-8859-1", "UTF7-IMAP" ); 
+								$elem['uid'] = $new_search->Msgno;
+								$elem['flag'] = $elem['msg_number']->Unseen.$elem['msg_number']->Flagged.$elem['msg_number']->Answered.$elem['msg_number']->Draft;
+								/* compare dates in ordering */
+								$elem['from'] = $elem['msg_number']->from[0]->personal ? $elem['msg_number']->from[0]->personal : $elem['msg_number']->from[0]->mailbox . "@" . $elem['msg_number']->from[0]->host;
+								$elem['Size'] = $elem['msg_number']->Size;
+								$elem['subject'] = mb_convert_encoding(self::decodeMimeString($elem['msg_number']->subject), 'UTF-8',mb_detect_encoding(self::decodeMimeString($elem['msg_number']->subject).'x', 'UTF-8, ISO-8859-1'));
+								$elem['udatecomp'] = substr ($elem['udate'], -4) ."-". substr ($elem['udate'], 3, 2) ."-". substr ($elem['udate'], 0, 2);  
+								$filter = array('AND', array('=', 'folderName', $name_box), array('=','messageNumber', $new_search));
+								$followupflagged = Controller::find(
+											array('concept' => 'followupflagged'),
+											false, 
+											array('filter' => $filter, 'criteria' => array('deepness' => '2'))
+										);
+
+								if(isset($followupflagged[0]['followupflagId']))
+								{
+									$followupflag = Controller::read( array( 'concept' => 'followupflag', 'id' => $followupflagged[0]['followupflagId'] ));     
+									$followupflagged[0]['followupflag'] = $followupflag;
+									$elem['followupflagged'] = $followupflagged[0];
+								}	
+
+								$labeleds = Controller::find(
+											array('concept' => 'labeled'),
+											false, 
+											array('filter' => $filter, 'criteria' => array('deepness' => '2'))
+										);
+								foreach ($labeleds as $e)
+								{
+									$labels = Controller::read( array( 'concept' => 'label', 'id' =>  $e['labelId']));
+									$elem['labels'][$e['labelId']] = $labels;
+								}											
+                                         	   		$retorno[] = $elem;
+							//}
+						//}
+					}
 				}
+			}
+			imap_close($this->mbox);
+			$num_msgs = count($retorno);
+			/* Comparison functions, descendent is ascendent with parms inverted */
+			function SORTDATE($a, $b){ return ($a['udatecomp'] < $b['udatecomp']); }
+			function SORTDATE_REVERSE($b, $a) { return SORTDATE($a,$b); }
+
+			function SORTWHO($a, $b) { return (strtoupper($a['from']) > strtoupper($b['from'])); }
+			function SORTWHO_REVERSE($b, $a) { return SORTWHO($a,$b); }
+
+			function SORTSUBJECT($a, $b) { return (strtoupper($a['subject']) > strtoupper($b['subject'])); }
+			function SORTSUBJECT_REVERSE($b, $a) { return SORTSUBJECT($a,$b); }
+
+			function SORTBOX($a, $b) { return ($a['boxname'] > $b['boxname']); }
+			function SORTBOX_REVERSE($b, $a) { return SORTBOX($a,$b); }
+
+			function SORTSIZE($a, $b) { return ($a['size'] > $b['size']); }
+			function SORTSIZE_REVERSE($b, $a) { return SORTSIZE($a,$b); }
+
+			usort( $retorno, $params['sort_type']);
+			$pageret = array_slice( $retorno, $params['page'] * $this->prefs['max_email_per_page'], $this->prefs['max_email_per_page']);
+		    
+			$arrayRetorno['num_msgs']	=  $num_msgs;
+			$arrayRetorno['data']		=  $pageret;
+			$arrayRetorno['currentTab'] =  $params['current_tab'];
+
+			print_r(json_encode($arrayRetorno));
+			return;
+		}
+		else
+		{
+			$params['page'] = $params['page'] * 1;
+
+	    		if( is_array($search) )
+	   		{
+				$search = array_unique($search); // Remove duplicated folders
+				//print_r($search);
+				$search_criteria = '';
+				$search_result_number = $_SESSION['phpgw_info']['user']['preferences']['expressoMail']['search_result_number'];
+				foreach($search as $tmp)
+				{
+					$tmp1 = explode("##",$tmp);
+					//print_r($tmp1);
+					$sum = 0;
+					$name_box = $tmp1[0];
+					//unset($filter);
+					$filter = "";
+					foreach($tmp1 as $index => $criteria)
+					{
+						if ($index != 0 && strlen($criteria) != 0)
+						{
+							$filter_array = explode("<=>",html_entity_decode(rawurldecode($criteria)));
+							$filter .= " ".$filter_array[0];
+							if (strlen($filter_array[1]) != 0)
+							{
+								if ( trim($filter_array[0]) != 'BEFORE' &&
+										 trim($filter_array[0]) != 'SINCE' &&
+										 trim($filter_array[0]) != 'ON')
+								{
+									$filter .= '"'.$filter_array[1].'"';
+								}
+								else if(trim($filter_array[0]) == 'BEFORE' )
+								{
+                                                            		$filter .= '"'.$this->make_search_date($filter_array[1],true).'"';
+								}
+								else
+								{
+									$filter .= '"'.$this->make_search_date($filter_array[1]).'"';
+								}
+							}
+						}
+					}
 				
-				$name_box = mb_convert_encoding(utf8_decode($name_box), "UTF7-IMAP", "ISO-8859-1" );
-				$filter = $this->remove_accents($filter);
-
-				//Este bloco tem a finalidade de transformar o login (quando numerico) das pastas compartilhadas em common name
-				if ($_SESSION['phpgw_info']['user']['preferences']['expressoMail']['uid2cn'] && substr($name_box,0,4) == 'user')
-				{
-					$folder_name = explode($this->imap_delimiter,$name_box);
-					$this->ldap = new ldap_functions();
-					
-					if ($cn = $this->ldap->uid2cn($folder_name[1]))
+					$name_box = mb_convert_encoding(utf8_decode($name_box), "UTF7-IMAP", "ISO-8859-1" );
+					$filter = $this->remove_accents($filter);
+
+					//Este bloco tem a finalidade de transformar o login (quando numerico) das pastas compartilhadas em common name
+					if ($_SESSION['phpgw_info']['user']['preferences']['expressoMail']['uid2cn'] && substr($name_box,0,4) == 'user')
 					{
-						$folder_name[1] = $cn;
+						$folder_name = explode($this->imap_delimiter,$name_box);
+						$this->ldap = new ldap_functions();
+						
+						if ($cn = $this->ldap->uid2cn($folder_name[1]))
+						{
+							$folder_name[1] = $cn;
+						}
+						$folder_name = implode($this->imap_delimiter,$folder_name);
 					}
-					$folder_name = implode($this->imap_delimiter,$folder_name);
-				}
-				else
-					$folder_name = mb_convert_encoding(utf8_decode($name_box), "UTF7-IMAP", "ISO-8859-1" );
+					else
+					{
+						$folder_name = mb_convert_encoding(utf8_decode($name_box), "UTF7-IMAP", "ISO-8859-1" );
+					}
 				
-	
-			        $this->open_mbox($name_box);
-
-				if (preg_match("/^.?\bALL\b/", $filter))
-				{ 
-					// Quick Search, note: this ALL isn't the same ALL from imap_search
-					$all_criterias = array ("TO","SUBJECT","FROM","CC");
-					    
-					foreach($all_criterias as $criteria_fixed)
+					//print_r($filter);
+					//print("<br/>");
+				
+				        $this->open_mbox($name_box);
+
+					if (preg_match("/^.?\bALL\b/", $filter))
+					{ 
+						// Quick Search, note: this ALL isn't the same ALL from imap_search
+						$all_criterias = array ("TO","SUBJECT","FROM","CC");
+						
+						foreach($all_criterias as $criteria_fixed)
+						{
+							$_filter = $criteria_fixed . substr($filter,4);
+						
+							$search_criteria = imap_search($this->mbox, $_filter, SE_UID);
+						
+							if(is_array($search_criteria))
+							{
+								foreach($search_criteria as $new_search)
+								{
+									$elem = $this->get_info_head_msg($new_search);
+
+									$elem['udate']       = gmdate('d/m/Y', $elem['udate'] + $this->functions->CalculateDateOffset()); 
+									$elem['boxname'] = mb_convert_encoding( $name_box, "ISO-8859-1", "UTF7-IMAP" );
+									$elem['uid'] = $new_search;
+        	                                                        /* compare dates in ordering */
+									$elem['udatecomp'] = substr ($elem['udate'], -4) ."-". substr ($elem['udate'], 3, 2) ."-". substr ($elem['udate'], 0, 2);
+									$retorno[] = $elem; 
+								}
+							}
+						}
+					}
+					else
 					{
-						$_filter = $criteria_fixed . substr($filter,4);
-						
-						$search_criteria = imap_search($this->mbox, $_filter, SE_UID);
-						
-						if(is_array($search_criteria))
+						$search_criteria = imap_search($this->mbox, $filter, SE_UID);
+						if($_SESSION['phpgw_info']['user']['preferences']['expressoMail']['use_important_flag'])
+						{
+							if((!strpos($filter,"FLAGGED") === false) || (!strpos($filter,"UNFLAGGED") === false))
+							{
+								$num_msgs = imap_num_msg($this->mbox);
+								$flagged_msgs = array();
+								for ($i=$num_msgs; $i>0; $i--)
+								{
+									$iuid = @imap_uid($this->mbox,$i);
+									$header = $this->get_header($iuid);
+									if(trim($header->Flagged))
+									{
+										$flagged_msgs[$i] = $iuid;
+									}
+								}
+								if((count($flagged_msgs) >0) && (strpos($filter,"UNFLAGGED") === false))
+								{
+									$arry_diff = is_array($search_criteria) ? array_diff($flagged_msgs,$search_criteria):$flagged_msgs;
+									foreach($arry_diff as $msg)
+									{
+										$search_criteria[] = $msg;
+									}
+								}
+								else if((count($flagged_msgs) >0) && (is_array($search_criteria)) && (!strpos($filter,"UNFLAGGED") === false))
+								{
+									$search_criteria = array_diff($search_criteria,$flagged_msgs);
+								}
+							}
+						}
+
+						if( is_array( $search_criteria) )
 						{
 							foreach($search_criteria as $new_search)
 							{
-								$elem = $this->get_info_head_msg($new_search);
-								$elem['udate']       = gmdate('d/m/Y', $elem['udate'] + $this->functions->CalculateDateOffset()); 
+								$elem = $this->get_info_head_msg( $new_search );
+								$elem['udate']       = gmdate('d/m/Y', $elem['udate'] + $this->functions->CalculateDateOffset());
 								$elem['boxname'] = mb_convert_encoding( $name_box, "ISO-8859-1", "UTF7-IMAP" ); 
 								$elem['uid'] = $new_search;
-                                                                /* compare dates in ordering */
-								$elem['udatecomp'] = substr ($elem['udate'], -4) ."-". substr ($elem['udate'], 3, 2) ."-". substr ($elem['udate'], 0, 2);
-								$retorno[] = $elem; 
+								/* compare dates in ordering */
+								$elem['udatecomp'] = substr ($elem['udate'], -4) ."-". substr ($elem['udate'], 3, 2) ."-". substr ($elem['udate'], 0, 2);  
+								$filter = array('AND', array('=', 'folderName', $name_box), array('=','messageNumber', $new_search));
+								$followupflagged = Controller::find(
+											array('concept' => 'followupflagged'),
+											false, 
+											array('filter' => $filter, 'criteria' => array('deepness' => '2'))
+										);
+
+								if(isset($followupflagged[0]['followupflagId']))
+								{
+									$followupflag = Controller::read( array( 'concept' => 'followupflag', 'id' => $followupflagged[0]['followupflagId'] ));     
+									$followupflagged[0]['followupflag'] = $followupflag;
+									$elem['followupflagged'] = $followupflagged[0];
+								}	
+
+								$labeleds = Controller::find(
+											array('concept' => 'labeled'),
+											false, 
+											array('filter' => $filter, 'criteria' => array('deepness' => '2'))
+										);
+								foreach ($labeleds as $e)
+								{
+									$labels = Controller::read( array( 'concept' => 'label', 'id' =>  $e['labelId']));
+									$elem['labels'][$e['labelId']] = $labels;
+								}											
+                                         	   		$retorno[] = $elem;
 							}
 						}
 					}
 				}
-				else{
-					$search_criteria = imap_search($this->mbox, $filter, SE_UID);
-                                    if($_SESSION['phpgw_info']['user']['preferences']['expressoMail']['use_important_flag'])
-                                    {
-                                        if((!strpos($filter,"FLAGGED") === false) || (!strpos($filter,"UNFLAGGED") === false))
-                                        {
-                                            $num_msgs = imap_num_msg($this->mbox);
-                                            $flagged_msgs = array();
-                                            for ($i=$num_msgs; $i>0; $i--)
-                                            {
-                                                $iuid = @imap_uid($this->mbox,$i);
-                                                $header = $this->get_header($iuid);
-                                                if(trim($header->Flagged))
-                                                {
-                                                        $flagged_msgs[$i] = $iuid;
-                                                }
-                                            }
-						if((count($flagged_msgs) >0) && (strpos($filter,"UNFLAGGED") === false))
-                                            {
-                                                    $arry_diff = is_array($search_criteria) ? array_diff($flagged_msgs,$search_criteria):$flagged_msgs;
-                                                    foreach($arry_diff as $msg)
-                                            {
-							$search_criteria[] = $msg;
-                                            }
-                                        }
-						else if((count($flagged_msgs) >0) && (is_array($search_criteria)) && (!strpos($filter,"UNFLAGGED") === false))
-                                        {
-                                                    $search_criteria = array_diff($search_criteria,$flagged_msgs);
-                                        }
-                                    }
-                                    }
-
-                                    if( is_array( $search_criteria) )
-                                    {
-                                        foreach($search_criteria as $new_search)
-                                        {
-										
-                                            $elem = $this->get_info_head_msg( $new_search );
-                                            $elem['udate']       = gmdate('d/m/Y', $elem['udate'] + $this->functions->CalculateDateOffset()); 
-											$elem['boxname'] = mb_convert_encoding( $name_box, "ISO-8859-1", "UTF7-IMAP" ); 
-                                            $elem['uid'] = $new_search;
-                                            /* compare dates in ordering */
-                                            $elem['udatecomp'] = substr ($elem['udate'], -4) ."-". substr ($elem['udate'], 3, 2) ."-". substr ($elem['udate'], 0, 2);  
-
-											$filter = array('AND', array('=', 'folderName', $name_box), array('=','messageNumber', $new_search));
-											$followupflagged = Controller::find(
-												array('concept' => 'followupflagged'),
-												false, 
-												array('filter' => $filter, 'criteria' => array('deepness' => '2'))
-											);
-
-											if(isset($followupflagged[0]['followupflagId']))
-											{
-												$followupflag = Controller::read( array( 'concept' => 'followupflag', 'id' => $followupflagged[0]['followupflagId'] ));     
-												$followupflagged[0]['followupflag'] = $followupflag;
-												$elem['followupflagged'] = $followupflagged[0];
-
-											}	
-											$labeleds = Controller::find(
-												array('concept' => 'labeled'),
-												false, 
-												array('filter' => $filter, 'criteria' => array('deepness' => '2'))
-											);
-											foreach ($labeleds as $e){
-												$labels = Controller::read( array( 'concept' => 'label', 'id' =>  $e['labelId']));     
-												$elem['labels'][$e['labelId']] = $labels;
-}											
-                                            $retorno[] = $elem;
-                                        }
-                                    }
-				}
-			}
-		}
-		
-            imap_close($this->mbox);
-	    $num_msgs = count($retorno);
-	    /* Comparison functions, descendent is ascendent with parms inverted */
-	    function SORTDATE($a, $b){ return ($a['udatecomp'] < $b['udatecomp']); }
-	    function SORTDATE_REVERSE($b, $a) { return SORTDATE($a,$b); }
-
-	    function SORTWHO($a, $b) { return (strtoupper($a['from']) > strtoupper($b['from'])); }
-	    function SORTWHO_REVERSE($b, $a) { return SORTWHO($a,$b); }
-
-	    function SORTSUBJECT($a, $b) { return (strtoupper($a['subject']) > strtoupper($b['subject'])); }
-	    function SORTSUBJECT_REVERSE($b, $a) { return SORTSUBJECT($a,$b); }
-
-	    function SORTBOX($a, $b) { return ($a['boxname'] > $b['boxname']); }
-	    function SORTBOX_REVERSE($b, $a) { return SORTBOX($a,$b); }
-
-	    function SORTSIZE($a, $b) { return ($a['size'] > $b['size']); }
-	    function SORTSIZE_REVERSE($b, $a) { return SORTSIZE($a,$b); }
-
-	    usort( $retorno, $params['sort_type']);
-	    $pageret = array_slice( $retorno, $params['page'] * $this->prefs['max_email_per_page'], $this->prefs['max_email_per_page']);
+			}
+		}
+
+		imap_close($this->mbox);
+		$num_msgs = count($retorno);
+		/* Comparison functions, descendent is ascendent with parms inverted */
+		function SORTDATE($a, $b){ return ($a['udatecomp'] < $b['udatecomp']); }
+		function SORTDATE_REVERSE($b, $a) { return SORTDATE($a,$b); }
+
+		function SORTWHO($a, $b) { return (strtoupper($a['from']) > strtoupper($b['from'])); }
+		function SORTWHO_REVERSE($b, $a) { return SORTWHO($a,$b); }
+
+		function SORTSUBJECT($a, $b) { return (strtoupper($a['subject']) > strtoupper($b['subject'])); }
+		function SORTSUBJECT_REVERSE($b, $a) { return SORTSUBJECT($a,$b); }
+
+		function SORTBOX($a, $b) { return ($a['boxname'] > $b['boxname']); }
+		function SORTBOX_REVERSE($b, $a) { return SORTBOX($a,$b); }
+
+		function SORTSIZE($a, $b) { return ($a['size'] > $b['size']); }
+		function SORTSIZE_REVERSE($b, $a) { return SORTSIZE($a,$b); }
+
+		usort( $retorno, $params['sort_type']);
+		$pageret = array_slice( $retorno, $params['page'] * $this->prefs['max_email_per_page'], $this->prefs['max_email_per_page']);
 	    
-	    $arrayRetorno['num_msgs']	=  $num_msgs;
-	    $arrayRetorno['data']		=  $pageret;
-	    $arrayRetorno['currentTab'] =  $params['current_tab'];
-            return ($pageret) ? $arrayRetorno : 'none';
+		$arrayRetorno['num_msgs']	=  $num_msgs;
+		$arrayRetorno['data']		=  $pageret;
+		$arrayRetorno['currentTab'] =  $params['current_tab'];	
+
+		return ($pageret) ? $arrayRetorno : 'none';
 	}
 
@@ -4921,5 +5213,16 @@
 		call_user_func_array('array_multisort', $params);
 		$ret = array();
-		$keys = array();
+		$keys = array();$solrConfig = array(
+						'adapteroptions' => array(
+						'host' => '127.0.0.1',
+					        'port' => 8983,
+		        			'path' => '/solr/',
+					)
+				);
+				//echo("damn");
+				// create a client instance
+				$solariumClient = new Solarium_Client($solrConfig);
+				$solrQuery = $solariumClient->createSelect();
+				$usernameAux = $this->username;
 		$first = true;
 		foreach ($colarr as $col => $arr) {
@@ -4951,8 +5254,13 @@
 	function quickSearchMail( $params )
 	{		
-		include '../prototype/api/controller.php';			
+		include '../prototype/api/controller.php';
+		include 'solrclient/library/Solarium/Autoloader.php';
+		Solarium_Autoloader::register();
+
 		set_time_limit(270); //Aumenta o tempo limit da requisição, em algumas buscas o imap demora para retornar o resultado.
 		$return = array();
 		$return['folder'] = $params['folder'];
+		$useSolr = false;
+
 		if(!is_array($params['folder']))
 			$params['folder'] = array( $params['folder'] );
